#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "gui.h"

/*   gtk_object_set_user_data (GTK_OBJECT (gdisp->shell), (gpointer) gdisp); */

void destroy (GtkWidget *widget, gpointer *data)
{
  fprintf(stderr,"bye!\n");
  gtk_exit(0);
}


window *window_concat(window *win1, window* win2)
{
  window *temp;
  temp = win1;
  while (temp) {
    win1 = temp;
    temp = win1->next;
  }
  win1->next = win2;
  return win1;
}

window *w_list;

window *window_new(buffer *b) 
{
  window *w;
  buffer_page *bp;
  notepage *np;
  GtkWidget *gtkwindow;
  GtkWidget *windowbox;
  GtkWidget *notebook;
  GtkWidget *menubar;
  GtkWidget *filemenu;
  GtkWidget *menuitem;

  w = g_new(window,1);
  w->pages = NULL;

  for (bp=b->pages; bp; bp = bp->next) {
    np = npage_new(b,bp);
    if (NULL == w->pages) w->pages = np;
    else npage_concat(w->pages, np);
  }

  /* create a new window */
  gtkwindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (gtkwindow), VERSION);

  /* It's a good idea to do this for all windows. */
  gtk_signal_connect (GTK_OBJECT (gtkwindow), "delete_event",
		      (GtkSignalFunc) destroy,
		      &gtkwindow);
  /* sets the border width of the window. */
  gtk_container_border_width (GTK_CONTAINER (gtkwindow), 2);

  windowbox = gtk_vbox_new(FALSE, 0);
  
  /* put the box into the main window. */
  gtk_container_add (GTK_CONTAINER (gtkwindow), windowbox);
  gtk_widget_show (windowbox);

  menubar = gtk_menu_bar_new();
  filemenu = gtk_menu_new();
  menuitem = gtk_menu_item_new_with_label ("Open");
  gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
		      (GtkSignalFunc) load_callback,
		      NULL);
  gtk_menu_append (GTK_MENU (filemenu), menuitem);
  gtk_widget_show (menuitem);

  menuitem = gtk_menu_item_new_with_label ("Save");
  gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
		      (GtkSignalFunc) save_callback,
		      b);
  gtk_menu_append (GTK_MENU (filemenu), menuitem);
  gtk_widget_show (menuitem);

  menuitem = gtk_menu_item_new_with_label ("Quit");
  gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
		      (GtkSignalFunc) destroy,
		      &gtkwindow);
  gtk_menu_append (GTK_MENU (filemenu), menuitem);
  gtk_widget_show (menuitem);

  menuitem = gtk_menu_item_new_with_label ("File");
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem), filemenu);
  gtk_menu_bar_append (GTK_MENU_BAR (menubar), menuitem);
  gtk_widget_show (menuitem);
  
  notebook = gtk_notebook_new();
  gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook), GTK_POS_BOTTOM);
  gtk_box_pack_start (GTK_BOX (windowbox), menubar, FALSE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (windowbox), notebook, TRUE, TRUE, 0);
  gtk_widget_show (notebook);
  gtk_widget_show (menubar);

  for (np = w->pages; np; np = np->next ) {
    gtk_notebook_append_page (GTK_NOTEBOOK (notebook), 
			      np->npage_table, 
			      np->npage_label);
  }

  gtk_widget_show (gtkwindow);

  w = g_new(window,1);
  w->gtkwindow = gtkwindow;
  w->windowbox = windowbox;
  w->notebook = notebook;
  w->menubar = menubar;
  w->next = NULL;
  
  if (!w_list) {
    w_list = w;
  } else {
    window_concat(w_list,w);
  }
  
  return w;
}
